function a3_cg ( x0 )
% a3_CG - CG-Verfahren
%
% Synopsis:
%    a3_cg ( x0 )
%
% Return values:
%    (none)
%
% 2001-02-06, Stephan Engelke, Andreas Meister

maxiter = 1000;
example_1				% load constants, etc.
% example_2				% load constants, etc.

% $$$ B = [  1  1  1 1; 
% $$$       -1  1  1 1;
% $$$        1 -1  1 1;
% $$$        1  1 -1 1 ];
% $$$ 
% $$$ D = [ 1 12 25 17 ];
% $$$ A = B'*diag(D)*B;
% $$$ 
% $$$ b = [ 1 1 1 1 ]';

% $$$ A  = [ 2 0 ; 0 10 ];
% $$$ b  = [ 0; 0];
% $$$ x0 = [ 4; sqrt(1.8) ];

n   = size (A, 1);

eps = 1e-14;

r   = zeros ( n, 1 );
k   = 0;
x   = x0;

p = b - A * x0;
r = p;
alpha = norm( r )^2;

while ( (alpha > eps) & (k < maxiter) )
  
  v = A * p;
  lambda = alpha / (v'*p);
  x = x + lambda * p;
  
  r = r - lambda * v;
  
  alphanew = norm( r )^2;
  
  p = r + alphanew/alpha*p;
  alpha = alphanew;
  
  
  fprintf ('%4i\t%21.12e\n', k, alpha);

  k = k + 1;
end
